package org.ninjasoft.tastysafari.data;

import java.util.*;
import java.io.*;

/**
 * Class to load/save application properties.  It is mindful of the 
 * multiuser nature of the OS and sets permissions on the saved file
 * such that nobody else can read it (because it may contain a password).
 * 
 * @author enigma
 */
public class ApplicationProperties extends Properties {
    private String filename = ""; 
    public ApplicationProperties() throws IOException {
        super();
        filename = System.getProperty("user.home") + "/Library/Preferences/org.ninjasoft.tastysafari.properties";
        this.load();
    }
    
    public void load() throws IOException {
        File f = new File(filename);
        InputStream in = null;
        if (!f.exists())
            return;
        in = new FileInputStream(f);
        this.load(in);
        in.close();
    }
    
    public void save() throws IOException {
        File saveFile = new File(filename);
        File tempFile = new File(filename + ".temp");
        if (tempFile.exists())
            tempFile.delete();
        tempFile.createNewFile();
        // Boy, is this chmod cheesy:
        Runtime.getRuntime().exec("/bin/chmod 600 " + tempFile.getCanonicalPath());
        OutputStream out = new FileOutputStream(tempFile, true);
        this.store(out, "");
        out.close();
        saveFile.delete();
        tempFile.renameTo(saveFile);
        // The first chmod doesn't seem to stick...
        Runtime.getRuntime().exec("/bin/chmod 600 " + saveFile.getCanonicalPath());
    }
}
